import mongoose from 'mongoose'
import * as dotenv from 'dotenv'

const envFile = process.env.NODE_ENV && process.env.NODE_ENV === 'production' ? `.env.production` : '.env.development'
dotenv.config({ path: envFile })
console.log(process.env.DB_MAIN)
import { ActivityChest } from 'models/ActivityChest'
import { ScoreRecord } from 'models/ScoreRecord'
import { DeleteRecord } from 'models/DeleteRecord'
import { rankKey, updateRank, updateRankInvite } from 'services/rank.svr'
import { ZRedisClient } from 'zutils'
import { RANK_SCORE_SCALE } from 'common/Constants'
import { uuid } from 'zutils/utils/security.util'
const db = mongoose.connection

const totalKey = 'uaw_activity:score'
const keyInvite = `uaw_activity:invite`

const addItem = async (key, item) => {
  return new Promise((resolve, reject) => {
    new ZRedisClient().pub.sadd(key, item, () => {
      resolve(true)
    })
  })
}
;(async () => {
  try {
    let opts = { url: process.env.REDIS }
    new ZRedisClient(opts)
    for (let i = 0; i < 10; i++) {
      let id = uuid()
      await addItem('chest_bonus_1', id)
    }
    for (let i = 0; i < 100; i++) {
      let id = uuid()
      await addItem('chest_bonus_2', id)
    }
  } catch (e) {
    console.log(e)
  }
  console.log('end')
  process.exit(0)
})()
