import { dbconn } from 'decorators/dbconn'
import { getModelForClass, index, modelOptions, mongoose, prop } from '@typegoose/typegoose'
import { Severity } from '@typegoose/typegoose/lib/internal/constants'
import { BaseModule } from './Base'
/**
 * 宝箱券
 */
@dbconn()
@index({ type: 1 }, { unique: false })
@modelOptions({
  schemaOptions: { collection: 'delete_record', timestamps: true },
  options: { allowMixed: Severity.ALLOW },
})
export class DeleteRecordClass extends BaseModule {
  @prop()
  public type: string
  @prop({ type: mongoose.Schema.Types.Mixed })
  public data: any
}
export const DeleteRecord = getModelForClass(DeleteRecordClass, { existingConnection: DeleteRecordClass['db'] })
