import { dbconn } from 'decorators/dbconn'
import { getModelForClass, index, modelOptions, mongoose, prop } from '@typegoose/typegoose'
import { Severity } from '@typegoose/typegoose/lib/internal/constants'
import { BaseModule } from './Base'

/**
 * 用户登录记录
 */
@dbconn()
@index({ user: 1, activity: 1, wallet: 1 }, { unique: false })
@modelOptions({
  schemaOptions: { collection: 'user_login_record', timestamps: true },
  options: { allowMixed: Severity.ALLOW },
})
class LoginRecordClass extends BaseModule {
  @prop()
  public user: string
  @prop()
  public wallet: string
  @prop()
  public activity: string
  @prop()
  public referer: string
  @prop()
  public user_agent: string
  @prop()
  public ip: string
}
export const LoginRecord = getModelForClass(LoginRecordClass, { existingConnection: LoginRecordClass['db'] })
