import { getModelForClass, modelOptions, prop } from '@typegoose/typegoose'
import { dbconn } from 'decorators/dbconn'
import { BaseModule } from './Base'

export const DEFAULT_EXPIRED = 1000 * 60 * 5
@dbconn()
@modelOptions({ schemaOptions: { collection: 'nonce_record', timestamps: true } })
class NonceRecordClass extends BaseModule {
  @prop({ required: true, default: 0 })
  public status: number

  @prop({ required: true })
  public address: string

  @prop()
  public expired: number

  public static async removeExpired() {
    await NonceRecord.deleteMany({ expired: { $lt: Date.now() } })
  }
}

export const NonceRecord = getModelForClass(NonceRecordClass, { existingConnection: NonceRecordClass['db'] })
