import logger from 'logger/logger'
import { LoginRecord } from 'models/LoginRecord'
import { AsyncQueue, createAsyncQueue, singleton } from 'zutils'

@singleton
export class LoginRecordQueue {
  private queue: AsyncQueue

  constructor() {
    this.queue = createAsyncQueue()
  }

  public addLog(req, user, activity, wallet) {
    this.queue.push(async () => {
      const ip = req.headers['x-forwarded-for'] || req.ip
      try {
        const history = new LoginRecord({
          user,
          activity,
          wallet,
          referer: req.headers['referer'],
          user_agent: req.headers['user-agent'],
          ip,
        })
        await history.save()
      } catch (err) {
        logger.error('error add user login record: ')
        logger.error(err)
      }
    })
  }
}
