import { RECAPTCHA_MIN_SCORE } from 'common/Constants'
import { ZError } from 'zutils'

export const checkReCaptcha = async (req: any, action: string) => {
  if (!(process.env.NEED_RECAPTCHA && process.env.NEED_RECAPTCHA === '1')) {
    return
  }
  const { rtoken } = req.params
  if (!rtoken) {
    throw new ZError(50, 'reCaptcha token is required')
  }
  const url = `https://www.google.com/recaptcha/api/siteverify?secret=${process.env.RECAPTCHA_SECRET}&response=${rtoken}`
  const response = await fetch(url, {
    method: 'POST',
  })
  const data = await response.json()
  if (!data.success) {
    throw new ZError(51, `reCaptcha invalid`)
  }
  if (data.action !== action) {
    throw new ZError(52, `reCaptcha action invalid`)
  }
  if (data.score < RECAPTCHA_MIN_SCORE) {
    throw new ZError(53, `reCaptcha score invalid`)
  }
  return true
}
