import { checkDiscord } from 'services/oauth.svr'
import { ITask } from './base/ITask'
import { ZError } from 'zutils'
import { TaskStatusEnum } from 'models/ActivityUser'
import { TaskCfg } from 'models/ActivityInfo'

export default class DiscordConnect extends ITask {
  static desc = 'join discord'
  static show: boolean = true

  async execute(data: any) {
    const { address } = this.user
    const { task } = data
    const res = await checkDiscord(address)
    let cfg = this.activity.tasks.find((t: TaskCfg) => t.id === task.id)
    if (res.errcode) {
      throw new ZError(res.errcode, res.errmsg)
    }

    if (res.data.userid && task.status === TaskStatusEnum.RUNNING) {
      task.status = TaskStatusEnum.SUCCESS
      task.timeFinish = Date.now()
      task.data = res.data
      this.user.discordId = res.data.userid
      this.user.discordName = res.data.username
      try {
        await this.user.save()
      } catch (err) {
        throw new ZError(100, 'discord already binded to another account')
      }
      if (cfg.autoclaim) {
        try {
          await this.claimReward(task)
        } catch (err) {
          console.log(err)
        }
      }
    }
    return true
  }
}
