import { ITask } from './base/ITask'
import { ZError } from 'zutils'
import { TaskStatusEnum } from 'models/ActivityUser'
import { TaskCfg } from 'models/ActivityInfo'

export default class DiscordJoin extends ITask {
  static desc = 'join discord'
  static show: boolean = true

  async execute(data: any) {
    const { task } = data
    let cfg = this.activity.tasks.find((t: TaskCfg) => t.id === task.id)
    let time = cfg.params.time
    if (Date.now() - task.timeStart < time * 1000) {
      throw new ZError(11, 'check discord join failed')
    }
    let num = Math.random() * 100
    if (num < cfg.params.failRate) {
      throw new ZError(12, 'check discord join failed')
    }
    task.status = TaskStatusEnum.SUCCESS
    task.timeFinish = Date.now()
    task.data = {}
    try {
      await this.user.save()
    } catch (err) {
      throw new ZError(100, 'already join discord')
    }
    if (cfg.autoclaim) {
      try {
        await this.claimReward(task)
      } catch (err) {
        console.log(err)
      }
    }
    return true
  }
}
