import { ITask } from './base/ITask'
import { ZError } from 'zutils'
import { TaskStatusEnum } from 'models/ActivityUser'
import { TaskCfg } from 'models/ActivityInfo'
import { LoginRecord } from 'models/LoginRecord'

export default class OkxLogin extends ITask {
  static desc = 'okx wallet login'
  static show: boolean = true

  async execute(data: any) {
    const { task } = data
    const { activity } = this.user
    let cfg = this.activity.tasks.find((t: TaskCfg) => t.id === task.id)
    let wallet = 'okx'
    let record = LoginRecord.findOne({ user: this.user.id, activity, wallet })
    if (!record) {
      throw new ZError(11, 'task not finished')
    }
    task.status = TaskStatusEnum.SUCCESS
    task.timeFinish = Date.now()
    try {
      await this.user.save()
    } catch (err) {
      throw new ZError(100, 'discord already binded')
    }
    if (cfg.autoclaim) {
      try {
        await this.claimReward(task)
      } catch (err) {
        console.log(err)
      }
    }
    return true
  }
}
