import { ZError } from 'zutils'
import { ITask } from './base/ITask'
import { TaskStatusEnum } from 'models/ActivityUser'

export default class TwitterLike extends ITask {
  static desc = 'twitter like'
  static show: boolean = true
  async execute(data: any) {
    const { task } = data
    let cfg = this.activity.tasks.find(t => t.id === task.id)
    let time = cfg.params.time
    if (Date.now() - task.timeStart < time * 1000) {
      throw new ZError(11, 'like failed')
    }
    let num = Math.random() * 100
    if (num < cfg.params.failRate) {
      throw new ZError(12, 'like failed')
    }
    task.status = TaskStatusEnum.SUCCESS
    task.timeFinish = Date.now()
    task.data = {}
    try {
      await this.user.save()
    } catch (err) {
      throw new ZError(100, 'save failed')
    }
    if (cfg.autoclaim) {
      try {
        await this.claimReward(task)
      } catch (err) {
        console.log(err)
      }
    }
    return true
  }
}
